/* Copyright (c) 2003 Andrew Stikheev. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *
 * $Id: statistics.h,v 1.14 2003/06/01 18:34:03 sand Exp $
 */

#ifndef STATISTICS_H_
#define STATISTICS_H_

//------------------------------------------------------------------------------
#define CLUSTER_SIZE  4
#define NUM_CLUSTERS  1009 

#define MAX_WEIGHT    1e6
#define MIN_WEIGHT    1.0 

//------------------------------------------------------------------------------
// 	weight += A * weight / ( 1 + B * d )
//------------------------------------------------------------------------------
/*
#define UPDATE_WEIGHT  Update1Weight

#define RATIO_A 	0.1
#define RATIO_B		1.0
*/


//------------------------------------------------------------------------------
//	weight += A * weight * MAX ( 1 - d / B , -1 )
//------------------------------------------------------------------------------

#define UPDATE_WEIGHT  Update2Weight  

#define RATIO_A		0.1
#define	RATIO_B		1.0


//------------------------------------------------------------------------------
typedef struct
{
        in_addr_t               srcIP;
        in_addr_t               lastDstIP;
        u_short                 lastDstPort;
        u_short                 lastSrcPort;
        double                  weight;
        long                    lastTime;
} statisticItem;

//------------------------------------------------------------------------------
typedef struct
{
        char                    totalItems;
        statisticItem           item[CLUSTER_SIZE];
} clusterItem;

//------------------------------------------------------------------------------
int			AddPacketToStat (char *);

#endif
